

' VB6/VBA declare statements for NAG C Library DLL Mark 26
' Copyright 2016, Numerical Algorithms Group Ltd, Oxford, UK.

' chapter s
   Declare Function nag_shifted_log Lib "CLW3226DE_nag.dll" Alias "s01bac" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_tanh Lib "CLW3226DE_nag.dll" Alias "s10aac" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_sinh Lib "CLW3226DE_nag.dll" Alias "s10abc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_cosh Lib "CLW3226DE_nag.dll" Alias "s10acc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_arctanh Lib "CLW3226DE_nag.dll" Alias "s11aac" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_arcsinh Lib "CLW3226DE_nag.dll" Alias "s11abc" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_arccosh Lib "CLW3226DE_nag.dll" Alias "s11acc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_exp_integral Lib "CLW3226DE_nag.dll" Alias "s13aac" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_cos_integral Lib "CLW3226DE_nag.dll" Alias "s13acc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_sin_integral Lib "CLW3226DE_nag.dll" Alias "s13adc" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_gamma Lib "CLW3226DE_nag.dll" Alias "s14aac" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_log_gamma Lib "CLW3226DE_nag.dll" Alias "s14abc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_polygamma_fun Lib "CLW3226DE_nag.dll" Alias "s14acc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_polygamma_deriv Lib "CLW3226DE_nag.dll" Alias "s14adc" ( _
    ByVal x As double, _
    ByVal n As long, _
    ByVal m As long, _
    ByRef ans As double, _
    ByRef fail As NagError _
   )

   Declare Function nag_real_polygamma Lib "CLW3226DE_nag.dll" Alias "s14aec" ( _
    ByVal x As double, _
    ByVal k As long, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_complex_polygamma Lib "CLW3226DE_nag.dll" Alias "s14afc" ( _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByVal k As long, _
    ByRef fail As NagError _
   ) as Complex

   Declare Function nag_complex_log_gamma Lib "CLW3226DE_nag.dll" Alias "s14agc" ( _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByRef fail As NagError _
   ) as Complex

   Declare Function nag_scaled_log_gamma Lib "CLW3226DE_nag.dll" Alias "s14ahc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_incomplete_gamma Lib "CLW3226DE_nag.dll" Alias "s14bac" ( _
    ByVal a As double, _
    ByVal x As double, _
    ByVal tol As double, _
    ByRef p As double, _
    ByRef q As double, _
    ByRef fail As NagError _
   )

   Declare Function nag_log_beta Lib "CLW3226DE_nag.dll" Alias "s14cbc" ( _
    ByVal a As double, _
    ByVal b As double, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_incomplete_beta Lib "CLW3226DE_nag.dll" Alias "s14ccc" ( _
    ByVal a As double, _
    ByVal b As double, _
    ByVal x As double, _
    ByRef w As double, _
    ByRef w1 As double, _
    ByRef fail As NagError _
   )

   Declare Function nag_cumul_normal Lib "CLW3226DE_nag.dll" Alias "s15abc" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_cumul_normal_complem Lib "CLW3226DE_nag.dll" Alias "s15acc" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_erfc Lib "CLW3226DE_nag.dll" Alias "s15adc" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_erf Lib "CLW3226DE_nag.dll" Alias "s15aec" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_dawson Lib "CLW3226DE_nag.dll" Alias "s15afc" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_erfcx Lib "CLW3226DE_nag.dll" Alias "s15agc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_complex_erfc Lib "CLW3226DE_nag.dll" Alias "s15ddc" ( _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByRef fail As NagError _
   ) as Complex

   Declare Function nag_bessel_y0 Lib "CLW3226DE_nag.dll" Alias "s17acc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_bessel_y1 Lib "CLW3226DE_nag.dll" Alias "s17adc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_bessel_j0 Lib "CLW3226DE_nag.dll" Alias "s17aec" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_bessel_j1 Lib "CLW3226DE_nag.dll" Alias "s17afc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_airy_ai Lib "CLW3226DE_nag.dll" Alias "s17agc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_airy_bi Lib "CLW3226DE_nag.dll" Alias "s17ahc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_airy_ai_deriv Lib "CLW3226DE_nag.dll" Alias "s17ajc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_airy_bi_deriv Lib "CLW3226DE_nag.dll" Alias "s17akc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_bessel_zeros Lib "CLW3226DE_nag.dll" Alias "s17alc" ( _
    ByVal a As double, _
    ByVal n As long, _
    ByVal mode As long, _
    ByVal rel As double, _
    ByRef x As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bessel_y0_vector Lib "CLW3226DE_nag.dll" Alias "s17aqc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bessel_y1_vector Lib "CLW3226DE_nag.dll" Alias "s17arc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bessel_j0_vector Lib "CLW3226DE_nag.dll" Alias "s17asc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bessel_j1_vector Lib "CLW3226DE_nag.dll" Alias "s17atc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_airy_ai_vector Lib "CLW3226DE_nag.dll" Alias "s17auc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_airy_bi_vector Lib "CLW3226DE_nag.dll" Alias "s17avc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_airy_ai_deriv_vector Lib "CLW3226DE_nag.dll" Alias "s17awc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_airy_bi_deriv_vector Lib "CLW3226DE_nag.dll" Alias "s17axc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_complex_bessel_y Lib "CLW3226DE_nag.dll" Alias "s17dcc" ( _
    ByVal fnu As double, _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByVal n As long, _
    ByVal scal As Nag_ScaleResType, _
    ByRef cy As Complex, _
    ByRef nz As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_complex_bessel_j Lib "CLW3226DE_nag.dll" Alias "s17dec" ( _
    ByVal fnu As double, _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByVal n As long, _
    ByVal scal As Nag_ScaleResType, _
    ByRef cy As Complex, _
    ByRef nz As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_complex_airy_ai Lib "CLW3226DE_nag.dll" Alias "s17dgc" ( _
    ByVal deriv As Nag_FunType, _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByVal scal As Nag_ScaleResType, _
    ByRef ai As Complex, _
    ByRef nz As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_complex_airy_bi Lib "CLW3226DE_nag.dll" Alias "s17dhc" ( _
    ByVal deriv As Nag_FunType, _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByVal scal As Nag_ScaleResType, _
    ByRef bi As Complex, _
    ByRef fail As NagError _
   )

   Declare Sub nag_complex_hankel Lib "CLW3226DE_nag.dll" Alias "s17dlc" ( _
    ByVal m As long, _
    ByVal fnu As double, _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByVal n As long, _
    ByVal scal As Nag_ScaleResType, _
    ByRef cy As Complex, _
    ByRef nz As long, _
    ByRef fail As NagError _
   )

   Declare Function nag_bessel_k0 Lib "CLW3226DE_nag.dll" Alias "s18acc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_bessel_k1 Lib "CLW3226DE_nag.dll" Alias "s18adc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_bessel_i0 Lib "CLW3226DE_nag.dll" Alias "s18aec" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_bessel_i1 Lib "CLW3226DE_nag.dll" Alias "s18afc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_bessel_k0_vector Lib "CLW3226DE_nag.dll" Alias "s18aqc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bessel_k1_vector Lib "CLW3226DE_nag.dll" Alias "s18arc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bessel_i0_vector Lib "CLW3226DE_nag.dll" Alias "s18asc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bessel_i1_vector Lib "CLW3226DE_nag.dll" Alias "s18atc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Function nag_bessel_k0_scaled Lib "CLW3226DE_nag.dll" Alias "s18ccc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_bessel_k1_scaled Lib "CLW3226DE_nag.dll" Alias "s18cdc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_bessel_i0_scaled Lib "CLW3226DE_nag.dll" Alias "s18cec" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_bessel_i1_scaled Lib "CLW3226DE_nag.dll" Alias "s18cfc" ( _
    ByVal x As double _
   ) As double

   Declare Sub nag_bessel_k0_scaled_vector Lib "CLW3226DE_nag.dll" Alias "s18cqc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bessel_k1_scaled_vector Lib "CLW3226DE_nag.dll" Alias "s18crc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bessel_i0_scaled_vector Lib "CLW3226DE_nag.dll" Alias "s18csc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bessel_i1_scaled_vector Lib "CLW3226DE_nag.dll" Alias "s18ctc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_complex_bessel_k Lib "CLW3226DE_nag.dll" Alias "s18dcc" ( _
    ByVal fnu As double, _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByVal n As long, _
    ByVal scal As Nag_ScaleResType, _
    ByRef cy As Complex, _
    ByRef nz As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_complex_bessel_i Lib "CLW3226DE_nag.dll" Alias "s18dec" ( _
    ByVal fnu As double, _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByVal n As long, _
    ByVal scal As Nag_ScaleResType, _
    ByRef cy As Complex, _
    ByRef nz As long, _
    ByRef fail As NagError _
   )

   Declare Function nag_bessel_i_nu_scaled Lib "CLW3226DE_nag.dll" Alias "s18ecc" ( _
    ByVal x As double, _
    ByVal nu As long, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_bessel_k_nu_scaled Lib "CLW3226DE_nag.dll" Alias "s18edc" ( _
    ByVal x As double, _
    ByVal nu As long, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_bessel_i_nu Lib "CLW3226DE_nag.dll" Alias "s18eec" ( _
    ByVal x As double, _
    ByVal nu As long, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_bessel_k_nu Lib "CLW3226DE_nag.dll" Alias "s18efc" ( _
    ByVal x As double, _
    ByVal nu As long, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_bessel_k_alpha Lib "CLW3226DE_nag.dll" Alias "s18egc" ( _
    ByVal x As double, _
    ByVal ia As long, _
    ByVal ja As long, _
    ByVal nl As long, _
    ByRef b As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bessel_k_alpha_scaled Lib "CLW3226DE_nag.dll" Alias "s18ehc" ( _
    ByVal x As double, _
    ByVal ia As long, _
    ByVal ja As long, _
    ByVal nl As long, _
    ByRef b As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bessel_i_alpha Lib "CLW3226DE_nag.dll" Alias "s18ejc" ( _
    ByVal x As double, _
    ByVal a As double, _
    ByVal nl As long, _
    ByRef b As Complex, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bessel_j_alpha Lib "CLW3226DE_nag.dll" Alias "s18ekc" ( _
    ByVal x As double, _
    ByVal a As double, _
    ByVal nl As long, _
    ByRef b As Complex, _
    ByRef fail As NagError _
   )

   Declare Sub nag_complex_bessel_j_seq Lib "CLW3226DE_nag.dll" Alias "s18gkc" ( _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByVal a As double, _
    ByVal nl As long, _
    ByRef b As Complex, _
    ByRef fail As NagError _
   )

   Declare Function nag_kelvin_ber Lib "CLW3226DE_nag.dll" Alias "s19aac" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_kelvin_bei Lib "CLW3226DE_nag.dll" Alias "s19abc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_kelvin_ker Lib "CLW3226DE_nag.dll" Alias "s19acc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_kelvin_kei Lib "CLW3226DE_nag.dll" Alias "s19adc" ( _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_kelvin_ber_vector Lib "CLW3226DE_nag.dll" Alias "s19anc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_kelvin_bei_vector Lib "CLW3226DE_nag.dll" Alias "s19apc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_kelvin_ker_vector Lib "CLW3226DE_nag.dll" Alias "s19aqc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_kelvin_kei_vector Lib "CLW3226DE_nag.dll" Alias "s19arc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ivalid As long, _
    ByRef fail As NagError _
   )

   Declare Function nag_fresnel_s Lib "CLW3226DE_nag.dll" Alias "s20acc" ( _
    ByVal x As double _
   ) As double

   Declare Function nag_fresnel_c Lib "CLW3226DE_nag.dll" Alias "s20adc" ( _
    ByVal x As double _
   ) As double

   Declare Sub nag_fresnel_s_vector Lib "CLW3226DE_nag.dll" Alias "s20aqc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_fresnel_c_vector Lib "CLW3226DE_nag.dll" Alias "s20arc" ( _
    ByVal n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef fail As NagError _
   )

   Declare Function nag_elliptic_integral_rc Lib "CLW3226DE_nag.dll" Alias "s21bac" ( _
    ByVal x As double, _
    ByVal y As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_elliptic_integral_rf Lib "CLW3226DE_nag.dll" Alias "s21bbc" ( _
    ByVal x As double, _
    ByVal y As double, _
    ByVal z As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_elliptic_integral_rd Lib "CLW3226DE_nag.dll" Alias "s21bcc" ( _
    ByVal x As double, _
    ByVal y As double, _
    ByVal z As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_elliptic_integral_rj Lib "CLW3226DE_nag.dll" Alias "s21bdc" ( _
    ByVal x As double, _
    ByVal y As double, _
    ByVal z As double, _
    ByVal r As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_elliptic_integral_F Lib "CLW3226DE_nag.dll" Alias "s21bec" ( _
    ByVal phi As double, _
    ByVal dm As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_elliptic_integral_E Lib "CLW3226DE_nag.dll" Alias "s21bfc" ( _
    ByVal phi As double, _
    ByVal dm As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_elliptic_integral_pi Lib "CLW3226DE_nag.dll" Alias "s21bgc" ( _
    ByVal dn As double, _
    ByVal phi As double, _
    ByVal dm As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_elliptic_integral_complete_K Lib "CLW3226DE_nag.dll" Alias "s21bhc" ( _
    ByVal dm As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_elliptic_integral_complete_E Lib "CLW3226DE_nag.dll" Alias "s21bjc" ( _
    ByVal dm As double, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_real_jacobian_elliptic Lib "CLW3226DE_nag.dll" Alias "s21cac" ( _
    ByVal u As double, _
    ByVal m As double, _
    ByRef sn As double, _
    ByRef cn As double, _
    ByRef dn As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_jacobian_elliptic Lib "CLW3226DE_nag.dll" Alias "s21cbc" ( _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByVal ak2 As double, _
    ByRef sn As Complex, _
    ByRef cn As Complex, _
    ByRef dn As Complex, _
    ByRef fail As NagError _
   )

   Declare Function nag_jacobian_theta Lib "CLW3226DE_nag.dll" Alias "s21ccc" ( _
    ByVal k As long, _
    ByVal x As double, _
    ByVal q As double, _
    ByRef fail As NagError _
   ) As double

   Declare Function nag_general_elliptic_integral_f Lib "CLW3226DE_nag.dll" Alias "s21dac" ( _
    ByVal zRe as Double, ByVal zIm as Double, _
    ByVal akp As double, _
    ByVal a As double, _
    ByVal b As double, _
    ByRef fail As NagError _
   ) as Complex

   Declare Sub nag_legendre_p Lib "CLW3226DE_nag.dll" Alias "s22aac" ( _
    ByVal mode As long, _
    ByVal x As double, _
    ByVal m As long, _
    ByVal nl As long, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_specfun_1f1_real Lib "CLW3226DE_nag.dll" Alias "s22bac" ( _
    ByVal a As double, _
    ByVal b As double, _
    ByVal x As double, _
    ByRef m As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_specfun_1f1_real_scaled Lib "CLW3226DE_nag.dll" Alias "s22bbc" ( _
    ByVal ani As double, _
    ByVal adr As double, _
    ByVal bni As double, _
    ByVal bdr As double, _
    ByVal x As double, _
    ByRef frm As double, _
    ByRef scm As long, _
    ByRef fail As NagError _
   )

   Declare Function nag_specfun_2f1_real Lib "CLW3226DE_nag.dll" Alias "s22bec" ( _
    ByVal a As double, _
    ByVal b As double, _
    ByVal c As double, _
    ByVal x As double, _
    ByRef fail As NagError _
   ) As double

   Declare Sub nag_specfun_2f1_real_scaled Lib "CLW3226DE_nag.dll" Alias "s22bfc" ( _
    ByVal ani As double, _
    ByVal adr As double, _
    ByVal bni As double, _
    ByVal bdr As double, _
    ByVal cni As double, _
    ByVal cdr As double, _
    ByVal x As double, _
    ByRef frf As double, _
    ByRef scf As long, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bsm_price Lib "CLW3226DE_nag.dll" Alias "s30aac" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal s As double, _
    ByRef t As double, _
    ByVal sigma As double, _
    ByVal r As double, _
    ByVal q As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_bsm_greeks Lib "CLW3226DE_nag.dll" Alias "s30abc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As long, ByVal n As long, _
    ByRef x As double, ByVal s As double, ByRef t As double, _
    ByVal sigma As double, ByVal r As double, ByVal q As double, _
    ByRef p As double, ByRef delta As double, ByRef gamma As double, _
    ByRef vega As double, ByRef theta As double, ByRef rho As double, _
    ByRef crho As double, ByRef vanna As double, ByRef charm As double, _
    ByRef speed As double, ByRef colour As double, ByRef zomma As double, _
    ByRef vomma As double, ByRef fail As NagError _
   )

   Declare Sub nag_lookback_fls_price Lib "CLW3226DE_nag.dll" Alias "s30bac" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef sm As double, _
    ByVal s As double, _
    ByRef t As double, _
    ByVal sigma As double, _
    ByVal r As double, _
    ByVal q As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_lookback_fls_greeks Lib "CLW3226DE_nag.dll" Alias "s30bbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As long, ByVal n As long, _
    ByRef sm As double, ByVal s As double, ByRef t As double, _
    ByVal sigma As double, ByVal r As double, ByVal q As double, _
    ByRef p As double, ByRef delta As double, ByRef gamma As double, _
    ByRef vega As double, ByRef theta As double, ByRef rho As double, _
    ByRef crho As double, ByRef vanna As double, ByRef charm As double, _
    ByRef speed As double, ByRef colour As double, ByRef zomma As double, _
    ByRef vomma As double, ByRef fail As NagError _
   )

   Declare Sub nag_binary_con_price Lib "CLW3226DE_nag.dll" Alias "s30cac" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal s As double, _
    ByVal k As double, _
    ByRef t As double, _
    ByVal sigma As double, _
    ByVal r As double, _
    ByVal q As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_binary_con_greeks Lib "CLW3226DE_nag.dll" Alias "s30cbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As long, ByVal n As long, _
    ByRef x As double, ByVal s As double, ByVal k As double, _
    ByRef t As double, ByVal sigma As double, ByVal r As double, _
    ByVal q As double, ByRef p As double, ByRef delta As double, _
    ByRef gamma As double, ByRef vega As double, ByRef theta As double, _
    ByRef rho As double, ByRef crho As double, ByRef vanna As double, _
    ByRef charm As double, ByRef speed As double, ByRef colour As double, _
    ByRef zomma As double, ByRef vomma As double, ByRef fail As NagError _
   )

   Declare Sub nag_binary_aon_price Lib "CLW3226DE_nag.dll" Alias "s30ccc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal s As double, _
    ByRef t As double, _
    ByVal sigma As double, _
    ByVal r As double, _
    ByVal q As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_binary_aon_greeks Lib "CLW3226DE_nag.dll" Alias "s30cdc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As long, ByVal n As long, _
    ByRef x As double, ByVal s As double, ByRef t As double, _
    ByVal sigma As double, ByVal r As double, ByVal q As double, _
    ByRef p As double, ByRef delta As double, ByRef gamma As double, _
    ByRef vega As double, ByRef theta As double, ByRef rho As double, _
    ByRef crho As double, ByRef vanna As double, ByRef charm As double, _
    ByRef speed As double, ByRef colour As double, ByRef zomma As double, _
    ByRef vomma As double, ByRef fail As NagError _
   )

   Declare Sub nag_barrier_std_price Lib "CLW3226DE_nag.dll" Alias "s30fac" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal typ As Nag_Barrier, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal s As double, _
    ByVal h As double, _
    ByVal k As double, _
    ByRef t As double, _
    ByVal sigma As double, _
    ByVal r As double, _
    ByVal q As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_jumpdiff_merton_price Lib "CLW3226DE_nag.dll" Alias "s30jac" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal s As double, _
    ByRef t As double, _
    ByVal sigma As double, _
    ByVal r As double, _
    ByVal lambda As double, _
    ByVal jvol As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_jumpdiff_merton_greeks Lib "CLW3226DE_nag.dll" Alias "s30jbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As long, ByVal n As long, _
    ByRef x As double, ByVal s As double, ByRef t As double, _
    ByVal sigma As double, ByVal r As double, ByVal lambda As double, _
    ByVal jvol As double, ByRef p As double, ByRef delta As double, _
    ByRef gamma As double, ByRef vega As double, ByRef theta As double, _
    ByRef rho As double, ByRef vanna As double, ByRef charm As double, _
    ByRef speed As double, ByRef colour As double, ByRef zomma As double, _
    ByRef vomma As double, ByRef fail As NagError _
   )

   Declare Sub nag_heston_price Lib "CLW3226DE_nag.dll" Alias "s30nac" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal s As double, _
    ByRef t As double, _
    ByVal sigmav As double, _
    ByVal kappa As double, _
    ByVal corr As double, _
    ByVal var0 As double, _
    ByVal eta As double, _
    ByVal grisk As double, _
    ByVal r As double, _
    ByVal q As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_heston_greeks Lib "CLW3226DE_nag.dll" Alias "s30nbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As long, ByVal n As long, _
    ByRef x As double, ByVal s As double, ByRef t As double, _
    ByVal sigmav As double, ByVal kappa As double, ByVal corr As double, _
    ByVal var0 As double, ByVal eta As double, ByVal grisk As double, _
    ByVal r As double, ByVal q As double, ByRef p As double, _
    ByRef delta As double, ByRef gamma As double, ByRef vega As double, _
    ByRef theta As double, ByRef rho As double, ByRef vanna As double, _
    ByRef charm As double, ByRef speed As double, ByRef zomma As double, _
    ByRef vomma As double, ByRef fail As NagError _
   )

   Declare Sub nag_heston_term Lib "CLW3226DE_nag.dll" Alias "s30ncc" ( _
    ByVal opt As Nag_CallPut, _
    ByVal m As long, _
    ByVal numts As long, _
    ByRef x As double, _
    ByVal fwd As double, _
    ByVal disc As double, _
    ByRef ts As double, _
    ByVal t As double, _
    ByRef alpha As double, _
    ByRef lambda As double, _
    ByRef corr As double, _
    ByRef sigmat As double, _
    ByVal var0 As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_amer_bs_price Lib "CLW3226DE_nag.dll" Alias "s30qcc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal s As double, _
    ByRef t As double, _
    ByVal sigma As double, _
    ByVal r As double, _
    ByVal q As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_asian_geom_price Lib "CLW3226DE_nag.dll" Alias "s30sac" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, _
    ByVal m As long, _
    ByVal n As long, _
    ByRef x As double, _
    ByVal s As double, _
    ByRef t As double, _
    ByVal sigma As double, _
    ByVal r As double, _
    ByVal b As double, _
    ByRef p As double, _
    ByRef fail As NagError _
   )

   Declare Sub nag_asian_geom_greeks Lib "CLW3226DE_nag.dll" Alias "s30sbc" ( _
    ByVal order as Nag_OrderType, _
    ByVal opt As Nag_CallPut, ByVal m As long, ByVal n As long, _
    ByRef x As double, ByVal s As double, ByRef t As double, _
    ByVal sigma As double, ByVal r As double, ByVal b As double, _
    ByRef p As double, ByRef delta As double, ByRef gamma As double, _
    ByRef vega As double, ByRef theta As double, ByRef rho As double, _
    ByRef crho As double, ByRef vanna As double, ByRef charm As double, _
    ByRef speed As double, ByRef colour As double, ByRef zomma As double, _
    ByRef vomma As double, ByRef fail As NagError _
   )

